(******************************************************************************)
(* Fusion Folder Keeper - Transpear Software                                  *)
(******************************************************************************)
{                                                                              }
{ VERSION      : 1.2                                                           }
{ AUTHOR       : Kelvin Westlake                                               }
{ CREATED      : 22 Semptember 2000                                            }
{ WEBSITE      : http://www.Transpear.cjb.net                                  }
{ EMAIL        : KWestlae@yahoo.com                                            }
{                                                                              }
{ NOTES:  Please the enclosed text files                                       }
{******************************************************************************}

unit Misc;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs,shellapi,registry,shlobj,ActiveX, ComObj;


// A little class that will run your program on Windows start-up.
// Just create the type fill in the details and set AutoRun=TRUE.
Type TTFAutoStart = class(TComponent)
     Public
       Procedure OnStartup(Name, Path :string;AutoRun:boolean);
       Function  GetStat(FileName: String): Boolean;
     End;



// Reads selective information about a shortcut file.
procedure ReadShortCut(fShortcutFile : String;  Var fTarget : String;
               Var fIconLocation:String; Var fIconNumber : Integer);



function SystemDir:String;   //  Returns the system directory for Windows
function DesktopDir: String;


// Extract Icon, if not it will return a default Icon.
function ExtractIconFromFile(const FileName : String;
                             nIndex   : Integer; Shortcut : Boolean) : tIcon;




implementation


///////////////////////////////////////////////////////////////////////////////
// Check to see if the specified file is set to autorun and returns a boolean
Function TTFAutoStart.GetStat(FileName: String): Boolean;
Begin
 With TRegistry.Create DO
 Begin
   RootKey:=HKEY_LOCAL_MACHINE;
   OpenKey('Software\Microsoft\Windows\CurrentVersion\Run',False);
   Result:=ValueExists(FileName);
   Free;
  End;
End;



////////////////////////////////////////////////////////////////////////////////
// Will autostart a program when passed to it a name and file, and autorun is
// set to True,  to turn autorun off just set AutoRun=False
procedure TTFAutoStart.OnStartup(Name, Path : String; AutoRun: Boolean);
Begin
   If AutoRun Then
   Begin
    With TRegistry.Create DO
    Begin
     Rootkey:=HKEY_LOCAL_MACHINE;
     Openkey('Software\Microsoft\Windows\CurrentVersion\Run',False);
     WriteString(Name,Path);
     Free;
     End;
   End
   Else
   Begin
    With TRegistry.Create DO
    Begin
      RootKey:=HKEY_LOCAL_MACHINE;
      OpenKey('Software\Microsoft\Windows\CurrentVersion\Run',False);
      If ValueExists(Name) then DeleteValue(Name);
      Free;
    End;
   End;
End;


////////////////////////////////////////////////////////////////////////////////
// Will locate the default system folders

function DesktopDir: String;
var
  Buffer: array[0..MAX_PATH] of Char;
  PIDL: PItemIDList;
begin
  SHGetSpecialFolderLocation(0, CSIDL_DESKTOP, PIDL);
  SHGetPathFromIDList(PIDL, Buffer);
  Result := Buffer;
end;

function SystemDir:String;  // 'c:\winnt\system32' or 'c:\windows\system'
var
  tmp:Integer;
begin
  SetLength(result, MAX_PATH);
  tmp:=GetSystemDirectory(PChar(result), MAX_PATH);
  SetLength(result, tmp);
end;



////////////////////////////////////////////////////////////////////////////////
// Retrieves a Shortcuts Icon path and Target executable..

// This is an incredibly cut and custom version of the Short Cut component
// by Elliott Shevin, you can E-Mail him at: shevine@aol.com
procedure ReadShortCut(fShortcutFile : String;  Var fTarget : String;
               Var fIconLocation:String; Var fIconNumber : Integer);

Const    IID_IPersistFile: TGUID = (
      D1:$0000010B; D2:$0000; D3:$0000; D4:($C0,$00,$00,$00,$00,$00,$00,$46));

var X3      :  PChar;
    hresx   :  HResult;
    Psl     :  IShellLink;  //JR - changed from IShortcutLink to IShellLink
    Ppf     :  IPersistFile;
    Saver   :  Array [0..Max_Path] of WideChar;
    X1      :  Array [0..MAX_PATH-1] Of Char;  //JR - changed from 255 to MAX_PATH-1 (255 isn't big enough)
    Data    :  TWin32FindData;
    I       :  Integer;


begin
     //JR - changed CLSID_ShortcutLink and IID_IShortcutLink to CLSID_ShellLink and IID_IShellLinkA/IID_IShellLink
     hresx:=CoCreateInstance(CLSID_ShellLink,nil,CLSCTX_INPROC_SERVER,IID_IShellLinkA,psl);
     If hresx<>0 then Exit;
     hresx:=psl.QueryInterface(IID_IPersistFile,ppf);
     If hresx<>0 then Exit;
     X3:=StrAlloc(MAX_PATH);  //JR - changed from 255 to MAX_PATH
     StrPCopy(X3,fShortcutFile);  // Changed from S in Radek Voltr's TShellLink component
     MultiByteToWideChar(CP_ACP,0,X3,-1,Saver,Max_Path);
     hresx:=ppf.Load(Saver,STGM_READ);
     If hresx<>0 then
     begin
       Exit;
     end;
     hresx:=psl.Resolve(0,SLR_ANY_MATCH);
     If hresx<>0 then Exit;
     hresx:= psl.GetPath( @X1,MAX_PATH,Data,SLGP_UNCPRIORITY);
     If hresx<>0 then
        begin
//             ShowMessage('Error in retrieving shortcut getting Target');
             Exit;
        end;
        fTarget:=StrPas(@X1);

     hresx:=psl.GetIconLocation(@X1,MAX_PATH,I);  //JR - changed @I to I
     If hresx<>0 then
        begin
//             raise EShortcutError.Create('Error in getting icon data');
             Exit;
     end;
     fIconLocation:=StrPas(@X1);
     IF Length(fIconLocation)=0 THEN fIconLocation:=fTarget;
     fIconNumber:=I;
     StrDispose(X3);
end;



////////////////////////////////////////////////////////////////////////////////
// trys to extract a ICO from a file, if it fails it will load a default icon
function ExtractIconFromFile(const FileName : String;
                             nIndex   : Integer; Shortcut : Boolean) : tIcon;
var
  Icon : TIcon;
  hIco : HIcon;
  nResNum : Integer;

begin
  // Try to extract the icon from the file passed as argument
  IF Shortcut Then nResNum:=51 ELSE nResNum:=3;
  hIco := ExtractIcon(HInstance, PChar(FileName), nIndex);
  If hIco <> 0 then
  Begin
   Icon := TIcon.Create;
   Icon.ReleaseHandle;
   Icon.Handle := hIco;
   ExtractIconFromFile:=Icon;
  End
  Else    // if not then load a default file.
  Begin
     hIco := ExtractIcon(HInstance,PChar(SystemDir+'\shell32.dll'), nResNum);
     Icon := TIcon.Create;
     Icon.ReleaseHandle;
     Icon.Handle := hIco;
     ExtractIconFromFile:=Icon;
  End;
end;

end.


